#!/usr/bin/perl
use strict;
use warnings;

require "../config.pl";

# Parse original normal-behavior file.
# Usage: ./parse_normal_behavior_file.pl (file)

### Variables #############
my $input_file = $ARGV[0];
our $num_metrics;
our $num_samples;
my %data;
###########################

my $workload = 0;
my $count = 0;
print "Opening normal-behavior file...\n";
print "Configuration: num_metrics=$num_metrics, num_samples=$num_samples\n";
open FILE, $input_file or die $!;
while (my $line = <FILE>) {
	chomp($line);
	
	# Split values
	my @tmp = split(/,/, $line);
	
	for (my $i = 0; $i < $num_metrics; $i++) {
		for (my $j = 0; $j < $num_samples; $j++) {
			#my $index = $i * $num_metrics + $j;
			my $index = $i * $num_samples + $j;
			$data{$i}{$j + $workload} = $tmp[$index];
			$count++; 
		}
	}
	
	# Add offset for different workloads per line.
	$workload = $workload + $num_samples;
}
close(FILE);

print "Number of elements: $count\n";

### Print out file ###
print "Creating parsed file...\n";
open FILE, ">parsed_data" or die $!;
for (my $i = 0; $i < $num_metrics; $i++) {
	for (my $j = 0; $j < $workload; $j++) {
		print FILE "$data{$i}{$j}";
		if ($j != ($workload - 1)) {
			print FILE ",";
		} 
	}
	print FILE "\n";
	#print "Line: $i\n";
}
close(FILE);
